## 577acda65c.zip

=== Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000, 2001 by Lineo, inc.
# Written by Erik Andersen <andersen@lineo.com>, <andersee@debian.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

#--------------------------------------------------------
#
#There are a number of configurable options in "Config"
#
#--------------------------------------------------------

TOPDIR=./
include Rules.mak

DIRS = extra ldso libc libcrypt libresolv libutil libm  

all: headers uClibc_config.h subdirs shared done

Config:
	@echo
	@echo "You didn't read the README, did you... =)"
	@echo "Choose a configuration file in extras/Config/ and copy it to ./Config."
	@echo
	@exit 1

shared:
ifeq ($(strip $(HAVE_SHARED)),true)
	@$(MAKE) -C libc shared
	@$(MAKE) -C ldso shared
	@$(MAKE) -C libcrypt shared
	@$(MAKE) -C libutil shared
	@$(MAKE) -C libm shared
	@$(MAKE) -C libresolv shared
else
	@echo
	@echo Not building shared libraries...
	@echo
endif

done: shared
	@echo
	@echo Finally finished compiling...
	@echo

headers: dummy
	@rm -f include/asm include/linux include/bits
	@if [ $(TARGET_ARCH) = "powerpc" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-ppc include/asm; \
	elif [ $(TARGET_ARCH) = "v850" ];then \
	    ln -fs $(KERNEL_SOURCE)/include/asm-v850 include/asm; \
	else \
	    if [ $(HAS_MMU) != "true" ]; then \
			ln -fs $(KERNEL_SOURCE)/include/asm-$(TARGET_ARCH)nommu include/asm;\
		else \
			ln -fs $(KERNEL_SOURCE)/include/asm-$(TARGET_ARCH) include/asm; \
		fi; \
	fi;
	@if [ ! -f include/asm/unistd.h ] ; then \
	    echo " "; \
	    echo "The path '$(KERNEL_SOURCE)/include/asm' doesn't exist."; \
	    echo "I bet you didn't set KERNEL_SOURCE, TARGET_ARCH or HAS_MMU in \`Config'"; \
	    echo "correctly.  Please edit \`Config' and fix these settings."; \
	    echo " "; \
	    /bin/false; \
	fi;
	@if [ $(HAS_MMU) != "true" ]  && [ $(TARGET_ARCH) = "i386" ] ; then \
	    echo "WARNING: I bet your x86 system really has an MMU, right?"; \
	    echo "         malloc and friends won't work unless you fix \`Config'"; \
	    echo " "; \
	    sleep 10; \
	fi;
	@ln -fs $(KERNEL_SOURCE)/include/linux include/linux
	@ln -fs ../libc/sysdeps/linux/$(TARGET_ARCH)/bits include/bits
	(cd include/bits; ln -sf ../../../../../uClibc_config.h uClibc_config.h)
	$(MAKE) -C libc/sysdeps/linux/$(TARGET_ARCH) headers

uClibc_config.h: Makefile Config
	@echo "/* WARNING!!! AUTO-GENERATED FILE!!! DO NOT EDIT!!! */" > uClibc_config.h
	@echo "#if !defined __FEATURES_H && !defined __need_uClibc_config_h" >> uClibc_config.h
	@echo "#error Never include <bits/uClibc_config.h> directly; use <features.h> instead." >> uClibc_config.h
	@echo "#endif" >> uClibc_config.h
	@echo "#define linux 1" >> uClibc_config.h 
	@echo "#define __linux__ 1" >> uClibc_config.h 
	@if [ "$(INCLUDE_IPV6)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_IPV6__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_IPV6__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_MMU)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_MMU__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_MMU__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_FLOATING_POINT)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_FLOATS__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_FLOATS__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_LIBM_FLOAT)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LIBM_FLOAT__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LIBM_FLOAT__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_LIBM_DOUBLE)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LIBM_DOUBLE__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LIBM_DOUBLE__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_LIBM_LONG_DOUBLE)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LIBM_LONG_DOUBLE__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LIBM_LONG_DOUBLE__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_LONG_LONG)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LONG_LONG__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LONG_LONG__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAS_LOCALE)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_LOCALE__ 1" >> uClibc_config.h ; \
	    echo "#define __UCLIBC_LOCALE_DIR \""$(LOCALE_DIR)"\"" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_LOCALE__" >> uClibc_config.h ; \
	fi
	@if [ "$(HAVE_ELF)" = "false" ] ; then \
	    echo "#undef HAVE_ELF" >> uClibc_config.h ; \
	else \
	    echo "#define HAVE_ELF 1" >> uClibc_config.h ; \
	fi
	@if [ "$(HAVE_SHARED)" = "false" ] ; then \
	    echo "#undef HAVE_SHARED" >> uClibc_config.h ; \
	else \
	    echo "#define HAVE_SHARED 1" >> uClibc_config.h ; \
	fi
	@if [ "$(TARGET_ARCH)" = "sh" ] ; then \
	    echo "#define NO_UNDERSCORES 1" >> uClibc_config.h ; \
	else \
	    echo "#undef NO_UNDERSCORES" >> uClibc_config.h ; \
	fi
	@if [ "$(INCLUDE_RPC)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAS_RPC__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAS_RPC__" >> uClibc_config.h ; \
	fi
	@if [ "$(UNIFIED_SYSCALL)" = "true" ] ; then \
	    echo "#define __UCLIBC_USE_UNIFIED_SYSCALL__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_USE_UNIFIED_SYSCALL__" >> uClibc_config.h ; \
	fi
	@echo "#define C_SYMBOL_PREFIX "\""$(C_SYMBOL_PREFIX)"\" >> uClibc_config.h
	@if [ "$(DOLFS)" = "true" ] ; then \
	    echo "#define __UCLIBC_HAVE_LFS__ 1" >> uClibc_config.h ; \
	else \
	    echo "#undef __UCLIBC_HAVE_LFS__" >> uClibc_config.h ; \
	fi

subdirs: $(patsubst %, _dir_%, $(DIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

tags:
	ctags -R

install: install_dev install_runtime install_gcc


# Installs header files and development library links.
install_dev:
	install -d $(PREFIX)$(DEVEL_PREFIX)/lib
	install -m 644 lib/*.[ao] $(PREFIX)$(DEVEL_PREFIX)/lib/
	install -d $(PREFIX)$(DEVEL_PREFIX)/include
	install -d $(PREFIX)$(DEVEL_PREFIX)/usr/lib
	find include/ -name '*.h' -depth -follow -exec install \
	    -D -m 644 {} $(PREFIX)$(DEVEL_PREFIX)/'{}' ';'
ifeq ($(strip $(HAVE_SHARED)),true)
	find lib/ -type l -name '*.so' -exec cp -a {} $(PREFIX)$(DEVEL_PREFIX)/lib ';'
endif


# Installs run-time libraries and helper apps onto the host system
# allowing cross development.  If you want to deploy to a target 
# system, use the "install_target" target instead... 
install_runtime:
ifeq ($(strip $(HAVE_SHARED)),true)
	install -d $(PREFIX)$(DEVEL_PREFIX)/lib
	install -d $(PREFIX)$(DEVEL_PREFIX)/bin
	install -m 644 lib/lib*-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(DEVEL_PREFIX)/lib
	cp -a lib/*.so.* $(PREFIX)$(DEVEL_PREFIX)/lib
	install -m 755 ldso/util/ldd $(PREFIX)$(DEVEL_PREFIX)/bin
	install -m 755 ldso/util/readelf $(PREFIX)$(DEVEL_PREFIX)/bin
	install -d $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin
	ln -fs $(DEVEL_PREFIX)/bin/ldd $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-ldd
	ln -fs $(DEVEL_PREFIX)/bin/readelf $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-readelf
	if [ -x lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so ] ; then \
	    install -m 755 lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(DEVEL_PREFIX)/lib; \
	    mkdir -p $(PREFIX)$(SHARED_LIB_LOADER_PATH); \
	    ln -s $(DEVEL_PREFIX)/lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so \
	    		$(PREFIX)$(SHARED_LIB_LOADER_PATH)/$(UCLIBC_LDSO) || true; \
	fi;
	if [ -x ldso/util/ldconfig ] ; then \
	    install -d $(PREFIX)$(DEVEL_PREFIX)/etc; \
	    install -m 755 ldso/util/ldconfig $(PREFIX)$(DEVEL_PREFIX)/bin; \
	    ln -fs $(DEVEL_PREFIX)/sbin/ldconfig $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-ldconfig; \
	fi;
endif

install_gcc:
	$(MAKE) -C extra/gcc-uClibc install


# Installs run-time libraries and helper apps in preparation for
# deploying onto a target system, but installed below wherever
# $PREFIX is set to, allowing you to package up the result for
# deployment onto your target system.
install_target:
ifeq ($(strip $(HAVE_SHARED)),true)
	install -d $(PREFIX)$(TARGET_PREFIX)/lib
	install -d $(PREFIX)$(TARGET_PREFIX)/sbin
	install -d $(PREFIX)$(TARGET_PREFIX)/usr/bin
	install -m 644 lib/lib*-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(TARGET_PREFIX)/lib
	cp -a lib/*.so.* $(PREFIX)$(TARGET_PREFIX)/lib
	install -m 755 ldso/util/ldd $(PREFIX)$(TARGET_PREFIX)/usr/bin
	install -m 755 ldso/util/readelf $(PREFIX)$(TARGET_PREFIX)/usr/bin
	if [ -x lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so ] ; then \
	    install -m 755 lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so $(PREFIX)$(TARGET_PREFIX)/lib; \
	    mkdir -p $(PREFIX)$(SHARED_LIB_LOADER_PATH); \
	    ln -s $(TARGET_PREFIX)/lib/ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so \
	    		$(PREFIX)$(SHARED_LIB_LOADER_PATH)/$(UCLIBC_LDSO) || true; \
	fi;
	if [ -x ldso/util/ldconfig ] ; then \
	    install -d $(PREFIX)$(TARGET_PREFIX)/etc; \
	    install -m 755 ldso/util/ldconfig $(PREFIX)$(TARGET_PREFIX)/sbin; \
	fi;
endif

distclean clean:
	@rm -rf tmp lib include/bits/uClibc_config.h uClibc_config.h
	- find include -type l -exec rm -f {} \;
	- find . \( -name \*.o -o -name \*.a -o -name \*.so -o -name core -o -name .\#\* \) -exec rm -f {} \;
	$(MAKE) -C test clean
	$(MAKE) -C ldso clean
	$(MAKE) -C libc/unistd clean
	$(MAKE) -C libc/sysdeps/linux/common clean
	$(MAKE) -C libc/sysdeps/linux/$(TARGET_ARCH) clean
	$(MAKE) -C extra/gcc-uClibc clean

dist release: distclean
	cd ..;					\
	rm -rf uClibc-$(VERSION);		\
	cp -a uClibc uClibc-$(VERSION);		\
						\
	find uClibc-$(VERSION)/ -type d	\
				 -name CVS	\
		-exec rm -rf {} \; ;            \
						\
	tar -cvzf uClibc-$(VERSION).tar.gz --exclude CVS uClibc-$(VERSION)/;

.PHONY: dummy subdirs

=== ldso/Makefile ===
TOPDIR=../
include $(TOPDIR)Rules.mak

ALL_SUBDIRS = d-link libdl util


all:
ifeq ($(strip $(BUILD_UCLIBC_LDSO)),true)
	$(MAKE) -C $(LIBRARY_CACHE) d-link;
endif

shared:
ifeq ($(strip $(BUILD_UCLIBC_LDSO)),true)
	$(MAKE) -C $(LIBRARY_CACHE) libdl;
endif
	$(MAKE) -C $(LIBRARY_CACHE) util;

clean:
	set -e ; for d in $(ALL_SUBDIRS) ; do $(MAKE) -C $$d $@ ; done
	-find . -name '*~' | xargs rm -f

=== libc/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000, 2001 by Lineo, inc.
# Written by Erik Andersen <andersen@lineo.com>, <andersee@debian.org>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

#--------------------------------------------------------
#
#There are a number of configurable options in "Config"
#
#--------------------------------------------------------

TOPDIR=../
include $(TOPDIR)Rules.mak

DIRS = misc pwd_grp stdio string termios inet signal stdlib sysdeps unistd

all: halfclean subdirs $(LIBNAME) $(DO_SHARED)

$(LIBNAME): subdirs
	$(CROSS)ranlib $(LIBNAME)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBNAME)
	install -m 644 crt0.o $(LIBNAME) $(TOPDIR)lib

shared: $(TOPDIR)lib/$(LIBNAME)
	@rm -rf tmp
	@mkdir tmp
	@(cd tmp; CC=$(CC) LD=$(LD) NM=$(NM) AR=$(AR) /bin/sh ../../extra/scripts/get-needed-libgcc-objects.sh)
	if [ -s ./tmp/libgcc-need.a ] ; then \
		$(CC) -g $(LDFLAGS) -shared -o $(SHARED_FULLNAME) \
		    -Wl,-soname,$(SHARED_MAJORNAME) -Wl,--whole-archive \
		    ./$(LIBNAME) ./tmp/libgcc-need.a \
		    $(LDSO) -Wl,--dynamic-linker,$(DYNAMIC_LINKER); \
	else \
		$(CC) -g $(LDFLAGS) -shared -o $(SHARED_FULLNAME) \
		    -Wl,-soname,$(SHARED_MAJORNAME) -Wl,--whole-archive \
		    ./$(LIBNAME) $(LDSO)  -Wl,-dynamic-linker,$(DYNAMIC_LINKER); \
	fi
	@/bin/true #rm -rf tmp
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(SHARED_FULLNAME)
	install -m 644 $(SHARED_FULLNAME) $(TOPDIR)lib
	(cd ../lib; ln -sf $(SHARED_FULLNAME) libc.so);
	(cd ../lib; ln -sf $(SHARED_FULLNAME) $(SHARED_MAJORNAME));


halfclean:
	@rm -f $(LIBNAME) crt0.o uClibc_config.h
	@rm -f $(SHARED_FULLNAME) $(SHARED_MAJORNAME) uClibc-0.* libc.so*

tags:
	ctags -R

clean: subdirs_clean halfclean
	@rm -rf tmp
	rm -f include/asm include/linux include/bits

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(DIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy subdirs

=== libcrypt/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak

LIBCRYPT=libcrypt.a
LIBCRYPT_SHARED=libcrypt.so
LIBCRYPT_SHARED_FULLNAME=libcrypt-$(MAJOR_VERSION).$(MINOR_VERSION).so

CSRC = crypt.c des.c md5.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBCRYPT)

$(LIBCRYPT): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBCRYPT) $(OBJS)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBCRYPT)
	install -m 644 $(LIBCRYPT) $(TOPDIR)lib

$(OBJS): %.o : %.c
	$(TARGET_CC) $(TARGET_CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: all
	$(TARGET_CC) $(TARGET_LDFLAGS) -nostdlib -shared -o $(LIBCRYPT_SHARED_FULLNAME) \
	    -Wl,-soname,$(LIBCRYPT_SHARED).$(MAJOR_VERSION) -Wl,--whole-archive $(LIBCRYPT) -lc
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBCRYPT_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBCRYPT_SHARED_FULLNAME) $(TOPDIR)lib;
	(cd $(TOPDIR)lib; ln -sf $(LIBCRYPT_SHARED_FULLNAME) $(LIBCRYPT_SHARED)); 
	(cd $(TOPDIR)lib; ln -sf $(LIBCRYPT_SHARED_FULLNAME) $(LIBCRYPT_SHARED).$(MAJOR_VERSION)); 

clean: 
	rm -f *.[oa] *~ core $(LIBCRYPT_SHARED)* $(LIBCRYPT_SHARED_FULLNAME)*

=== libm/Makefile ===
# Makefile for uClibc's math library
# Copyright (C) 2001 by Lineo, inc.
#
# This math library is derived primarily from the Cephes Math Library,
# copyright by Stephen L. Moshier <moshier@world.std.com>
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

TOPDIR=../
include $(TOPDIR)Rules.mak

LIBM=libm.a
LIBM_SHARED=libm.so
LIBM_SHARED_FULLNAME=libm-$(MAJOR_VERSION).$(MINOR_VERSION).so

DIRS=
ifeq ($(strip $(HAS_LIBM_FLOAT)),true)
	DIRS+=float
endif
ifeq ($(strip $(HAS_LIBM_DOUBLE)),true)
	DIRS+=double
endif
ifeq ($(strip $(HAS_LIBM_LONG_DOUBLE)),true)
	DIRS+=ldouble
endif
ALL_SUBDIRS = float double ldouble

all: $(LIBM)

$(LIBM): subdirs
	@if [ -f $(LIBM) ] ; then \
		install -d $(TOPDIR)lib; \
		rm -f $(TOPDIR)lib/$(LIBM); \
		install -m 644 $(LIBM) $(TOPDIR)lib; \
	fi;

tags:
	ctags -R

shared: all
	if [ -f $(LIBM) ] ; then \
	    $(TARGET_CC) $(TARGET_LDFLAGS) -nostdlib -shared -o $(LIBM_SHARED_FULLNAME) \
		-Wl,-soname,$(LIBM_SHARED).$(MAJOR_VERSION) -Wl,--whole-archive $(LIBM) -lc; \
	    install -d $(TOPDIR)lib; \
	    rm -f $(TOPDIR)lib/$(LIBM_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBM_SHARED).$(MAJOR_VERSION); \
	    install -m 644 $(LIBM_SHARED_FULLNAME) $(TOPDIR)lib; \
	    (cd $(TOPDIR)lib; ln -sf $(LIBM_SHARED_FULLNAME) $(LIBM_SHARED)); \
	    (cd $(TOPDIR)lib; ln -sf $(LIBM_SHARED_FULLNAME) $(LIBM_SHARED).$(MAJOR_VERSION)); \
	fi;

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS)) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

clean: subdirs_clean
	rm -f *.[oa] *~ core $(LIBM_SHARED)* $(LIBM_SHARED_FULLNAME)*

.PHONY: dummy

=== libresolv/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak

LIBRESOLV=libresolv.a
LIBRESOLV_SHARED=libresolv.so
LIBRESOLV_SHARED_FULLNAME=libresolv-$(MAJOR_VERSION).$(MINOR_VERSION).so

CSRC = resolv.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBRESOLV)

$(LIBRESOLV): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBRESOLV) $(OBJS)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBRESOLV)
	install -m 644 $(LIBRESOLV) $(TOPDIR)lib

$(OBJS): %.o : %.c
	$(TARGET_CC) $(TARGET_CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: all
	$(TARGET_CC) $(TARGET_LDFLAGS) -nostdlib -shared -o $(LIBRESOLV_SHARED_FULLNAME) \
	    -Wl,-soname,$(LIBRESOLV_SHARED).$(MAJOR_VERSION) -Wl,--whole-archive $(LIBRESOLV) -lc
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBRESOLV_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBRESOLV_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBRESOLV_SHARED_FULLNAME) $(TOPDIR)lib;
	(cd $(TOPDIR)lib; ln -sf $(LIBRESOLV_SHARED_FULLNAME) $(LIBRESOLV_SHARED)); 
	(cd $(TOPDIR)lib; ln -sf $(LIBRESOLV_SHARED_FULLNAME) $(LIBRESOLV_SHARED).$(MAJOR_VERSION)); 

clean: 
	rm -f *.[oa] *~ core $(LIBRESOLV_SHARED)* $(LIBRESOLV_SHARED_FULLNAME)*

=== libutil/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Rules.mak
LIBC=$(TOPDIR)libc.a

LIBUTIL=libutil.a
LIBUTIL_SHARED=libutil.so
LIBUTIL_SHARED_FULLNAME=libutil-$(MAJOR_VERSION).$(MINOR_VERSION).so

CSRC=login.c login_tty.c logout.c logwtmp.c openpty.c
ifeq ($(strip $(HAS_MMU)),true)
    CSRC+=forkpty.c
endif
OBJS=$(patsubst %.c,%.o, $(CSRC))

all: $(OBJS) $(LIBC)

$(LIBC): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBUTIL) $(OBJS)
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBUTIL)
	install -m 644 $(LIBUTIL) $(TOPDIR)lib/

$(OBJS): %.o : %.c
	$(TARGET_CC) $(TARGET_CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

shared: all
	$(TARGET_CC) $(TARGET_LDFLAGS) -nostdlib -shared -o $(LIBUTIL_SHARED_FULLNAME) \
	    -Wl,-soname,$(LIBUTIL_SHARED).$(MAJOR_VERSION) -Wl,--whole-archive $(LIBUTIL) -lc
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBUTIL_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBUTIL_SHARED_FULLNAME) $(TOPDIR)lib/;
	(cd $(TOPDIR)lib; ln -sf $(LIBUTIL_SHARED_FULLNAME) $(LIBUTIL_SHARED)); 
	(cd $(TOPDIR)lib; ln -sf $(LIBUTIL_SHARED_FULLNAME) $(LIBUTIL_SHARED).$(MAJOR_VERSION)); 

clean:
	rm -f *.[oa] *~ core $(LIBUTIL_SHARED)* $(LIBUTIL_SHARED_FULLNAME)*

=== test/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.

TOPDIR=../
include $(TOPDIR)Config

.EXPORT_ALL_VARIABLES:


ALL_SUBDIRS = args assert ctype pwd_grp signal silly stdlib string unistd #misc
DIRS = $(ALL_SUBDIRS)
#ifeq ($(TARGET_ARCH), $(NATIVE_ARCH))
#	DIRS = $(ALL_SUBDIRS)
#else
#	DIRS =
#endif
ifeq ($(strip $(HAVE_SHARED)),true)
	DIRS += ldso
endif	

all: subdirs

tags:
	ctags -R
	
clean: subdirs_clean
	rm -f *.[oa] *~ core

subdirs: $(patsubst %, _dir_%, $(DIRS))
subdirs_clean: $(patsubst %, _dirclean_%, $(ALL_SUBDIRS))

$(patsubst %, _dir_%, $(DIRS)) : dummy
	$(MAKE) -C $(patsubst _dir_%, %, $@)

$(patsubst %, _dirclean_%, $(ALL_SUBDIRS) ldso) : dummy
	$(MAKE) -C $(patsubst _dirclean_%, %, $@) clean

.PHONY: dummy

=== extra/gcc-uClibc/Makefile ===
TOPDIR = ../../
include $(TOPDIR)Rules.mak

UCLIBC_DIR = $(shell (cd ../.. ; /bin/pwd))
GCC_BIN = $(shell which $(CC))
LD_BIN = $(shell which $(LD))
GCC_LIB = $(shell $(CC) -print-libgcc-file-name )
#GCCINCDIR inherited from Rules.mak

all: gcc-uClibc ld-uClibc

gcc-uClibc.h: $(TOPDIR)/Config
	@echo "/* this file was autogenerated by make */" > gcc-uClibc.h
	@echo "#define UCLIBC_TARGET_PREFIX " \"$(TARGET_PREFIX)\" >> gcc-uClibc.h
	@echo "#define UCLIBC_DEVEL_PREFIX " \"$(DEVEL_PREFIX)\" >> gcc-uClibc.h
	@echo "#define UCLIBC_BUILD_DIR " \"$(UCLIBC_DIR)/\" >> gcc-uClibc.h
	@echo "#define GCC_BIN " \"$(GCC_BIN)\" >> gcc-uClibc.h
	@echo "#define GCC_LIB " \"$(GCC_LIB)\" >> gcc-uClibc.h
	@echo "#define GCC_INCDIR " \"-I$(GCCINCDIR)/\" >> gcc-uClibc.h
	@echo "#define TARGET_ARCH " \"$(TARGET_ARCH)\" >> gcc-uClibc.h
	@echo "#define DYNAMIC_LINKER " \"$(DYNAMIC_LINKER)\" >> gcc-uClibc.h
	@echo "#define BUILD_DYNAMIC_LINKER " \"$(UCLIBC_DIR)/lib/$(UCLIBC_LDSO)\" >> gcc-uClibc.h

gcc-uClibc: gcc-uClibc.h gcc-uClibc.c
	gcc -Wall -O2 -s gcc-uClibc.c -o $(TARGET_ARCH)-uclibc-gcc

ld-uClibc:
	@echo "#!/bin/sh" > $(TARGET_ARCH)-uclibc-ld
	@echo "# This file was autogenerated by make" >> $(TARGET_ARCH)-uclibc-ld
	@echo "$(LD_BIN) -L- -L$(DEVEL_PREFIX)/lib -L$(DEVEL_PREFIX)/usr/lib "\
		"-L$(UCLIBC_DIR) \$$@" >> $(TARGET_ARCH)-uclibc-ld
	chmod a+x $(TARGET_ARCH)-uclibc-ld

install: all
	install -d $(PREFIX)$(DEVEL_PREFIX)/bin;
	install -d $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin;
	install -m 755 $(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/
	install -m 755 $(TARGET_ARCH)-uclibc-ld $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/
	ln -fs $(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-cc
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(DEVEL_PREFIX)/bin/gcc
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-gcc $(PREFIX)$(DEVEL_PREFIX)/bin/cc
	ln -fs $(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-ld $(PREFIX)$(DEVEL_PREFIX)/bin/ld
	for app in addr2line ar as cpp gasp nm objcopy \
	    objdump ranlib size strings strip; do \
	  ln -fs `which $(CROSS)$${app}` $(PREFIX)$(DEVEL_PREFIX)/bin/$${app}; \
	  ln -fs `which $(CROSS)$${app}` $(PREFIX)$(SYSTEM_DEVEL_PREFIX)/bin/$(TARGET_ARCH)-uclibc-$${app}; \
	done

clean:
	rm -f gcc-uClibc.h *-uclibc-gcc *-uclibc-ld core

=== ldso/ldso/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.


TOPDIR=../../
include $(TOPDIR)Rules.mak

TARGET_CFLAGS += #-DDL_DEBUG #-funroll-loops



LDSO_FULLNAME=ld-uClibc-$(MAJOR_VERSION).$(MINOR_VERSION).so
TARGET_CFLAGS+=-fPIC -D__PIC__ -DUCLIBC_TARGET_PREFIX=\"$(TARGET_PREFIX)\" \
	-DUCLIBC_DEVEL_PREFIX=\"$(DEVEL_PREFIX)\" \
	-DUCLIBC_BUILD_DIR=\"$(shell cd $(TOPDIR); pwd)\"
CSRC= boot1.c hash.c readelflib1.c $(TARGET_ARCH)/elfinterp.c
COBJS=$(patsubst %.c,%.o, $(CSRC))
ASRC=$(shell ls $(TARGET_ARCH)/*.S)
AOBJS=$(patsubst %.S,%.o, $(ASRC))
OBJS=$(AOBJS) $(COBJS)


all: lib

lib:: ld.so.h $(OBJS) $(DLINK_OBJS)
	$(TARGET_CC) -e _dl_boot $(TARGET_LDFLAGS) -nostdlib -shared -o $(LDSO_FULLNAME) \
	    -Wl,-soname,$(UCLIBC_LDSO) $(OBJS)
	install -d $(TOPDIR)lib 
	install -m 755 $(LDSO_FULLNAME) $(TOPDIR)lib
	(cd $(TOPDIR)lib;ln -sf $(LDSO_FULLNAME) $(UCLIBC_LDSO))

ld.so.h: Makefile
	echo "#define _dl_static_progname \""$(UCLIBC_LDSO)"\"" > ld.so.h

$(COBJS): %.o : %.c
	$(TARGET_CC) $(TARGET_CFLAGS) -I. -I./$(TARGET_ARCH) -I../libdl -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

clean::
	$(RM) -f $(UCLIBC_LDSO)* $(OBJS) $(LDSO_FULLNAME)* core *.o *.a *.s *.i tmp_make foo *~

=== ldso/libdl/Makefile ===
# Makefile for uClibc
#
# Copyright (C) 2000 by Lineo, inc.
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2 of the License, or (at your option) any
# later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more
# details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Derived in part from the Linux-8086 C library, the GNU C Library, and several
# other sundry sources.  Files within this library are copyright by their
# respective copyright holders.


TOPDIR=../../
include $(TOPDIR)Rules.mak

LIBDL=libdl.a
LIBDL_SHARED=libdl.so
LIBDL_SHARED_FULLNAME=libdl-$(MAJOR_VERSION).$(MINOR_VERSION).so

CSRC= dlib.c
OBJS=$(patsubst %.c,%.o, $(CSRC))

TARGET_CFLAGS += #-DUSE_CACHE #-fPIC -D__PIC__ #-funroll-loops

all: $(OBJS) $(LIBDL) shared

$(LIBDL): ar-target

ar-target: $(OBJS)
	$(AR) $(ARFLAGS) $(LIBDL) $(OBJS)
	#install -d $(TOPDIR)lib
	#rm -f $(TOPDIR)lib/$(LIBDL)
	#install -m 644 $(LIBDL) $(TOPDIR)lib


$(OBJS): %.o : %.c
	$(TARGET_CC) -I../d-link -I../d-link/$(TARGET_ARCH) $(TARGET_CFLAGS) -c $< -o $@
	$(STRIPTOOL) -x -R .note -R .comment $*.o

$(OBJ): Makefile

shared: all
	$(TARGET_CC) $(TARGET_LDFLAGS) -nostdlib -shared -o $(LIBDL_SHARED_FULLNAME) \
	    -Wl,-soname,$(LIBDL_SHARED).$(MAJOR_VERSION) -Wl,--whole-archive $(LIBDL) -lc
	install -d $(TOPDIR)lib
	rm -f $(TOPDIR)lib/$(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib/$(LIBDL_SHARED).$(MAJOR_VERSION)
	install -m 644 $(LIBDL_SHARED_FULLNAME) $(TOPDIR)lib;
	(cd $(TOPDIR)lib; ln -sf $(LIBDL_SHARED_FULLNAME) $(LIBDL_SHARED)); 
	(cd $(TOPDIR)lib; ln -sf $(LIBDL_SHARED_FULLNAME) $(LIBDL_SHARED).$(MAJOR_VERSION)); 

clean:
	$(RM) -f .depend $(LIBDL_SHARED)* $(LIBDL_SHARED_FULLNAME) core *.o *.a *.s *.i tmp_make foo *~

=== ldso/man/Makefile ===
include ../Config.mk

ALL = #ld.so.info

all:	$(ALL)

ld.so.info: ld.so.texi
	makeinfo $<

clean:
	rm -f $(ALL) *~

=== debian/changelog ===
uclibc (0.9.5-cvs20011011-1) unstable; urgency=low

  * Closes #104243

 -- David Schleef <ds@schleef.org>  Thu, 11 Oct 2001 13:29:02 -0700

uclibc (0.9.5-cvs20010702-1) unstable; urgency=low

  * Build from CVS
  * Can create cross-compiling library (but not cross packages)

 -- David Schleef <ds@schleef.org>  Mon,  2 Jul 2001 23:16:20 -0700

uclibc (0.9.5-cvs20010630-1) unstable; urgency=low

  * No, really.  Initial Release.  I mean it this time.
  * Clean up patch.

 -- David Schleef <ds@schleef.org>  Sat, 30 Jun 2001 17:12:41 -0700

uclibc (0.9.5-cvs20010626-1) unstable; urgency=low

  * No, really.  Initial Release.

 -- David Schleef <ds@schleef.org>  Thu, 28 Jun 2001 16:49:25 -0700

uclibc (0.9.5-cvs20010625-1) unstable; urgency=low

  * Initial Release.

 -- David Schleef <ds@schleef.org>  Mon, 25 Jun 2001 22:13:43 -0700

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: uclibc
Section: devel
Priority: optional
Maintainer: David Schleef <ds@schleef.org>
Build-Depends: debhelper, kernel-headers | kernel-headers-2.4.10
Standards-Version: 3.5.2

Package: libuclibc-dev
Section: devel
Architecture: any
Depends: ${shlibs:Depends}
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.

Package: libuclibc0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: A small implementation of the C library
 uClibc is an implementation of the standard C library that is
 much smaller than glibc, which makes it useful for embedded
 systems.

Package: uclibc-toolchain
Section: devel
Architecture: any
Depends: gcc|c-compiler, binutils, ${shlibs:Depends}
Conflicts: uclibc-gcc
Replaces: uclibc-gcc
Description: A compiler wrapper for uClibc
 This is a small wrapper for gcc, ld, and other toolchain utilities
 to do compilation against uClibc instead of the native libc.
 This package is used for cross compiling.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=1

#include version
major=$(shell grep '^MAJOR_VERSION' Rules.mak|sed 's/.*=//')
minor=$(shell grep '^MINOR_VERSION' Rules.mak|sed 's/.*=//')
version:=$(strip $(major)).$(strip $(minor))

target=$(DEB_HOST_GNU_CPU)
#target=powerpc

with_shared_libs=y
#ifeq ($(target),powerpc)
#with_shared_libs=n
#endif

ifneq ($(target),$(DEB_HOST_GNU_CPU))
target_suffix=-$(target)
endif

p_dev=libuclibc-dev$(target_suffix)
p_lib=libuclibc0$(target_suffix)
p_gcc=uclibc$(target_suffix)-toolchain

debian/control: debian/control.in debian/rules
	sed s/_TARGET_/$(target_suffix)/ debian/control.in >debian/control

build: build-stamp
build-stamp: debian/control
	dh_testdir

	# Add here commands to compile the package.
	cp extra/Configs/Config.$(target) Config

	echo '#Debian configuration overrides'  >>Config
ifneq ($(target),$(DEB_HOST_GNU_CPU))
	echo 'TARGET_ARCH = $(target)'  >>Config
	echo 'CROSS = $(target)-linux-'  >>Config
endif
	echo 'DOPIC = true'  >>Config
	echo 'SYSTEM_DEVEL_PREFIX = /usr'  >>Config
	echo 'DEVEL_PREFIX = /usr/$$(TARGET_ARCH)-linux-uclibc'  >>Config
	echo 'SHARED_LIB_LOADER_PATH = /lib'  >>Config
	#echo 'TARGET_PREFIX = /'  >>Config
ifeq ($(with_shared_libs),n)
	echo 'HAVE_SHARED = false' >>Config
endif
	echo 'KERNEL_SOURCE = '`echo /usr/src/kernel-headers-*|sed 's/ .*//'` >>Config

	$(MAKE)

	touch build-stamp

clean: debian/control
	dh_testdir
	dh_testroot
	rm -f build-stamp

	rm -f debian/$(p_dev)

	# Add here commands to clean up after the build process.
	-$(MAKE) clean

	dh_clean

install: build debian/control
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	-rm debian/$(p_dev)
	ln -s tmp debian/$(p_dev)

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install_dev PREFIX=`pwd`/debian/$(p_dev)
	$(MAKE) install_runtime PREFIX=`pwd`/debian/$(p_lib)
	$(MAKE) install_gcc PREFIX=`pwd`/debian/$(p_gcc)

	install -d debian/$(p_gcc)/usr/share/man/man1
	install -m 644 debian/uclibc-gcc.1 \
	  debian/$(p_gcc)/usr/share/man/man1/$(target)-uclibc-gcc.1
	(cd debian/$(p_gcc)/usr/share/man/man1; \
	  ln -sf $(target)-uclibc-gcc.1.gz $(target)-uclibc-cc.1.gz; \
	  ln -sf $(target)-uclibc-gcc.1.gz $(target)-uclibc-ld.1.gz; \
	  for x in addr2line ar as cpp gasp nm objcopy objdump ranlib \
	  size strings strip;do \
	    ln -sf $$x.1.gz $(target)-uclibc-$$x.1.gz;done)
	
	install -d debian/$(p_lib)/usr/share/man/man1
	install -m 644 debian/uclibc-ldd.1 \
	  debian/$(p_lib)/usr/share/man/man1/$(target)-uclibc-ldd.1
	install -m 644 debian/uclibc-ldconfig.1 \
	  debian/$(p_lib)/usr/share/man/man1/$(target)-uclibc-ldconfig.1

ifeq ($(with_shared_libs),y)
ifeq ($(target),$(DEB_HOST_GNU_CPU))
	mkdir -p debian/$(p_lib)/lib/
	ln -sf /usr/$(target)-linux-uclibc/lib/ld-uClibc.so.0 \
	  debian/$(p_lib)/lib/ld-uClibc.so.0
endif
endif

# Build architecture-independent files here.
binary-indep:

# Build architecture-dependent files here.
binary-arch: build install
#	dh_testversion
	dh_testdir
	dh_testroot

#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installpam
#	dh_installinit
	dh_installcron
#	dh_installmanpages -plibuclibc0
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms -Xld-uClibc
	# You may want to make some executables suid here.
#	dh_suidregister
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
ifeq ($(target),$(DEB_HOST_GNU_CPU))
	dh_shlibdeps --exclude=ld_uclibc -ldebian/$(p_lib)/usr/$(target)-linux-uclibc/lib
else
	dh_shlibdeps --exclude=lib
endif
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
